#include <mqx.h>
#include <bsp.h>
#include "main.h"

MQX_FILE_PTR output_port;
LWGPIO_STRUCT leds[4];
void SetOutput(int signal, boolean state);

void InitializeIO(void)
{
	
	lwgpio_init(&leds[0], BSP_LED1, LWGPIO_DIR_OUTPUT, LWGPIO_VALUE_NOCHANGE);
	lwgpio_set_functionality(&leds[0], BSP_LED1_MUX_GPIO);
	
	lwgpio_init(&leds[1], BSP_LED2, LWGPIO_DIR_OUTPUT, LWGPIO_VALUE_NOCHANGE);
	lwgpio_set_functionality(&leds[1], BSP_LED2_MUX_GPIO);
	
	lwgpio_init(&leds[2], BSP_LED3, LWGPIO_DIR_OUTPUT, LWGPIO_VALUE_NOCHANGE);
	lwgpio_set_functionality(&leds[2], BSP_LED2_MUX_GPIO);
	
	lwgpio_init(&leds[3], BSP_LED4, LWGPIO_DIR_OUTPUT, LWGPIO_VALUE_NOCHANGE);
	lwgpio_set_functionality(&leds[3], BSP_LED2_MUX_GPIO);
			
	
#if 0			
    GPIO_PIN_STRUCT pins1[] = {
        /* when opening, explicitly set output to 0 */
        BSP_LED1 | GPIO_PIN_STATUS_0,
        /* when opening, explicitly set output to 0 */
        BSP_LED2 | GPIO_PIN_STATUS_0,
        /* when opening, explicitly set output to 0 */
        BSP_LED3 | GPIO_PIN_STATUS_0,
        /* when opening, explicitly set output to 0 */
        BSP_LED4 | GPIO_PIN_STATUS_0,
        GPIO_LIST_END
    };
    
   /* open file containing pin1 set of pins/signals */
   if (NULL == (output_port = fopen("gpio:write", (char_ptr) &pins1 ))) 
   {
       printf("Opening file1 GPIO for pins1 failed.\n");
      _mqx_exit(-1);
   }
   
   /* write logical 1 to all signals in the file (fast) */
   if (IO_OK != ioctl(output_port, GPIO_IOCTL_WRITE_LOG1, NULL ))
   {
       printf("Writing to whole file1 failed.\n");
      _mqx_exit(-1);
   }
   
   _time_delay(2000);
   /* write logical 1 to all signals in the file (fast) */
   if (IO_OK != ioctl(output_port, GPIO_IOCTL_WRITE_LOG0, NULL ))
   {
       printf("Writing to pins1 of file1 failed.\n");
      _mqx_exit(-1);
   }
   
   return;
}

void SetOutput(int signal, boolean state)
{
    uint_32 set_value=0;

    static const uint_32 led1[] = 
    {
        BSP_LED1,
        GPIO_LIST_END
    };
    static const uint_32 led2[] = 
    {
        BSP_LED1,
        GPIO_LIST_END
    };
    static const uint_32 led3[] = 
    {
        BSP_LED1,
        GPIO_LIST_END
    };
    static const uint_32 led4[] = 
    {
        BSP_LED1,
        GPIO_LIST_END
    };

	switch (signal) 
	{
	    case 1:
	        ioctl(output_port, (state) ? GPIO_IOCTL_WRITE_LOG1 : GPIO_IOCTL_WRITE_LOG0, (pointer) &led1);
	    break;
	    case 2:
	        ioctl(output_port, (state) ? GPIO_IOCTL_WRITE_LOG1 : GPIO_IOCTL_WRITE_LOG0, (pointer) &led2);
	    break;
	    case 3:
	        ioctl(output_port, (state) ? GPIO_IOCTL_WRITE_LOG1 : GPIO_IOCTL_WRITE_LOG0,	(pointer) &led3);
	    break;
	    case 4:
	        ioctl(output_port, (state) ? GPIO_IOCTL_WRITE_LOG1 : GPIO_IOCTL_WRITE_LOG0,	(pointer) &led4);
	    break;
	}
#endif
}
