/*
 * http_client.c
 *
 *  Created on: Sep 10, 2011
 *      Author: B21149
 */

#include "main.h"
#include <lwmem.h>
#include <string.h>

int sample_rate = 30; //30 seconds
extern LWGPIO_STRUCT leds[4];


#define HOST           "twitter.com" 
#define PAGE           "/users/fsl_mcu.xml" //API used to update status
#define HTTP_PORT      80
#define USERAGENT      "HTMLGET 1.0"
#define CHARMAX        100

char credentials[CHARMAX]={0};


void executeCommand(char *s);
char *process_http();

char *process_http()
{
	char *query;
	char *tpl = "GET %s HTTP/1.0\r\n"
		        "Host: %s\r\n"
				"User-Agent: %s\r\n\r\n"
				;
	
	query = (char *)_lwmem_alloc_zero(strlen(PAGE)+
	                                  strlen(HOST)+
	                                  strlen(USERAGENT)+
	                                  strlen(tpl)-3); // -3 is to consider the the ending \0
	                                  
	sprintf(query, tpl, PAGE, HOST, USERAGENT);
    
    return query;
}

void http_client(uint_32 initial_data)
{
    char          TwitterBuff[CHARMAX]={0};
    char          user_pwd[] = {"fsl_mcu:xsw21qaz"}; //twitter account fsl_mcu, pwd: zaq12wsx
    char          twitteTag[] = "<text>";
    const char*   found = NULL;
    _ip_address   ipaddr;
    uint_32       value;
    char          *post;
    uint_32       sent = 0;
    uint_32       tmpres;
    char          recvBuf[1500] = {0};
    sockaddr_in   addr;
    uint_32       sock;
    uint_32       result;
    
    printf("HTTP client GET started\n\r");
    
    //Create the string to make the request to the twitter server
    post = process_http();
    
    //Getting Twitter Server IP
    if (!RTCS_resolve_ip_address(HOST, &ipaddr,NULL,0)) {
      printf("Error resolving IP address for %s using DNS Server at %d.%d.%d.%d\n",HOST,IPBYTES(LWDNS_server_ipaddr));
      _mqx_exit(1);
    }
   
	//Create the stream socket for the TCP connection
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock == RTCS_SOCKET_ERROR) 
    {
        return;
    } 
   
    //Set socket properties
    addr.sin_family      = AF_INET;
    addr.sin_port        = 0;
    addr.sin_addr.s_addr = INADDR_ANY;
   
    //Binding soccket
    result = bind(sock, &addr, sizeof(addr));
    if (result != RTCS_OK) 
    {
        return;
    } 

    //Set socket port and address
    addr.sin_port        = HTTP_PORT;
    addr.sin_addr.s_addr = ipaddr;

    //
    result = connect(sock, &addr, sizeof(addr));
    if (result != RTCS_OK)
    {
        printf("\nError--connect() failed with error code %lx.",result);
    } 
    else 
    {
        printf("\nConnected to %lx, port %d.",addr.sin_addr.s_addr, addr.sin_port);
    }

    printf("\nReady to send...\n");

    //Send the query to the server
    tmpres = send(sock, post, strlen(post), 0);
    while(sent < strlen(post))
    { 
        tmpres = send(sock, post+sent, strlen(post)-sent, 0);
        //printf("\nSent %d...\n",tmpres);
        if(tmpres == RTCS_ERROR)
        {
            tmpres = RTCS_geterror(sock);
            printf("\nCan't send query. Error:%x\n",tmpres);
            _mqx_exit(-1);
        }
        sent += tmpres;
    }
    
    printf("\nReady to receive...\n");
    
    //now it is time to receive the XML page
    memset(recvBuf, 0, sizeof(recvBuf));
    while((tmpres = recv(sock, recvBuf, sizeof(recvBuf), 0)) > 0)
    {
        //Search for <text> tag
    	found = strstr(recvBuf, twitteTag);
        if (found != NULL)
        {
            shutdown(sock, FLAG_CLOSE_TX);
            strncpy(TwitterBuff, found, CHARMAX-1);
            TwitterBuff[CHARMAX] = '\0';
            printf("Message twittered: %s\n", TwitterBuff);
            executeCommand((strstr(recvBuf, twitteTag) + 7));
            break;
        }
    }
   _task_abort;
}

/*Parsing the message and execute the command if it is recognized*/
void executeCommand(char *s){
			
	char* found;
	char *token;
	char *separator = ".";
	int n;
		
	token = strtok(s, separator);	

	if (strcmp(token, "spark")==0)
	{
		token = strtok(NULL, separator);
		if (strcmp(token, "led")==0)
		{
			token = strtok(NULL, separator);
			n = atoi(token);
			if(n >= 1 && n <= 4 )
			{
				token = strtok(NULL, separator);
				if(strcmp(token, "on")==0)
				{
					printf("\n\r Turn Led %d On",n);
					lwgpio_set_value(&leds[n-1], LWGPIO_VALUE_LOW);
				}
				if (strcmp(token, "off")==0)
				{
					printf("\n\r Turn Led %d Off", n);
					lwgpio_set_value(&leds[n-1], LWGPIO_VALUE_HIGH);
				}		
			}
		}
		if (strcmp(token, "samplerate")==0)
		{
			token = strtok(NULL, separator);
			n = atoi(token);
			if(n >= 1 && n <= 60 )
			{
				printf("Sample rate is %d minutes",n);
				sample_rate = n;
			}
		}	
	}
	else
	{
		printf("This is not an MCU command");	
	}
	
}
