/*
 * http_client.c
 *
 *  Created on: Sep 10, 2011
 *      Author: B21149
 */

#include "main.h"
#include <lwmem.h>
#include <string.h>

int samplerate = 5; //5 minutes

extern int base64_encode(char *source, int sourcelen, char *target, int targetlen);

#define HOST           "api.supertweet.net" 
#define SUPERTWEET_NET "supertweet.net"
#define PAGE           "/1/statuses/update.xml" //API used to update status
#define HTTP_PORT      80
#define USERAGENT      "HTMLPOST 1.0"
#define CHARMAX        100
//#define POST           "status=The sky is the limit"
#define POST           "status=.spark.led.1.on. Please!!"

char credentials[CHARMAX]={0};

char *process_http(char *poststr);

char *process_http(char *poststr)
{
	char *query;
	char *tpl = "POST %s HTTP/1.1\r\n"
	            "Authorization: Basic %s\r\n"
	            "User-Agent: %s\r\n"
		        "Host: %s\r\n"
		        "Accept: */*\r\n"
		        "Content-length: %d\r\n"
		        "Content-Type: application/x-www-form-urlencoded\r\n\r\n"
		        "%s";
	
	query = (char *)_lwmem_alloc_zero(strlen(PAGE)+
									  strlen(credentials)+
	                                  strlen(USERAGENT)+
	                                  strlen(HOST)+
	                                  strlen(poststr)+
	                                  strlen(tpl)-3); // -3 is to consider the the ending \0
	                                  
	sprintf(query, tpl, PAGE, credentials, USERAGENT, HOST, strlen(poststr), poststr);
    
    return query;
}

void http_client(uint_32 initial_data)
{
    char          TwitterBuff[CHARMAX]={0};
    char          user_pwd[] = {"fsl_mcu:xsw21qaz"}; //twitter account fsl_mcu, pwd: zaq12wsx
    char          twitteTag[] = "<text>";
    const char*   found = NULL;
    _ip_address   ipaddr;
    uint_32       value;
    char          *post;
    uint_32       sent = 0;
    uint_32       tmpres;
    char          recvBuf[1500] = {0};
    sockaddr_in   addr;
    uint_32       sock;
    uint_32       result;
    
    printf("HTTP client POST started\n\r");
    
    //encode the user and password for http basic authentication 
    base64_encode(user_pwd,strlen(user_pwd),credentials,CHARMAX);
    
    //Create the HTTP request based on the information provided in defines.
    //The define POST is the message to be posted in the twitter account.
    post = process_http(POST);
    
    printf("Query is:\n<<START>>\n%s\n<<END>>\n", post);
    
    //Resolve the IP address for the SUPERTWEET_NET host
    if (!RTCS_resolve_ip_address(SUPERTWEET_NET, &ipaddr,NULL,0)) {
      printf("Error resolving IP address for %s using DNS Server at %d.%d.%d.%d\n",SUPERTWEET_NET,IPBYTES(LWDNS_server_ipaddr));
      _mqx_exit(1);
    }
   
	//Create the stream socket for the TCP connection
    sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock == RTCS_SOCKET_ERROR) 
    {
        return;
    } 

    //used to reduce the socket's Tx and Rx buffers size.
    //value = 256;
    //setsockopt(sock, SOL_TCP,OPT_TBSIZE,&value,sizeof(value));
    //setsockopt(sock, SOL_TCP,OPT_RBSIZE,&value,sizeof(value)); 
   
    addr.sin_family      = AF_INET;
    addr.sin_port        = 0;
    addr.sin_addr.s_addr = INADDR_ANY;
   
    result = bind(sock, &addr, sizeof(addr));
    if (result != RTCS_OK) 
    {
        return;
    } 

    addr.sin_port        = HTTP_PORT;
    addr.sin_addr.s_addr = ipaddr;

    result = connect(sock, &addr, sizeof(addr));
    if (result != RTCS_OK)
    {
        printf("\nError--connect() failed with error code %lx.",result);
    } 
    else 
    {
        printf("\nConnected to %lx, port %d.",addr.sin_addr.s_addr, addr.sin_port);
    }

    printf("\nReady to send...\n");
    //Send the query to the server
    while(sent < strlen(post))
    { 
        tmpres = send(sock, post+sent, strlen(post)-sent, 0);
        printf("\nSent %d...\n",tmpres);
        if(tmpres == RTCS_ERROR)
        {
            tmpres = RTCS_geterror(sock);
            printf("\nCan't send query. Error:%x\n",tmpres);
            _mqx_exit(-1);
        }
        sent += tmpres;
    }
    
    printf("\nReady to receive...\n");
    //now it is time to receive the page
    memset(recvBuf, 0, sizeof(recvBuf));
    while((tmpres = recv(sock, recvBuf, sizeof(recvBuf), 0)) > 0)
    {
    	//Look for the <text> tag 
        found = strstr(recvBuf, twitteTag);
        
        if (found != NULL)
        {
        	//<text> tag was found that means the post was done correctly.
            shutdown(sock, FLAG_CLOSE_TX);
            strncpy(TwitterBuff, found, CHARMAX-1);

            TwitterBuff[CHARMAX] = '\0';
            printf("Message twittered: %s\n", TwitterBuff);
            break;
        }
    }
    //Abort the task so we can be ready for the next request
    _task_abort(MQX_NULL_TASK_ID);
}
