/****************************************************************************
* 
*   This file contains MQX only stationery code.
*
****************************************************************************/
#include "main.h"

extern void InitializeNetworking(uint_32 pcbs, uint_32 msgs, uint_32 sockets, boolean dhcp) ;
#define DEMOCFG_ENABLE_DHCP     1   

#if !BSPCFG_ENABLE_IO_SUBSYSTEM
#error This application requires BSPCFG_ENABLE_IO_SUBSYSTEM defined non-zero in user_config.h. Please recompile BSP with this option.
#endif


#ifndef BSP_DEFAULT_IO_CHANNEL_DEFINED
#error This application requires BSP_DEFAULT_IO_CHANNEL to be not NULL. Please set corresponding BSPCFG_ENABLE_TTYx to non-zero in user_config.h and recompile BSP with this option.
#endif


TASK_TEMPLATE_STRUCT MQX_template_list[] = 
{ 
/*  Task number, Entry point, Stack, Pri, String, Auto? */
   {MAIN_TASK,   Main_task,   1500,  9,   "main", MQX_AUTO_START_TASK},
   {CLIENT_TASK, http_client, 3000,  9,   "httpclient", 0},
   {0,           0,           0,     0,   0,      0,                 }
};

/*TASK*-----------------------------------------------------
* 
* Task Name    : Main_task
* Comments     :
*    This task prints " Hello World "
*
*END*-----------------------------------------------------*/

void Main_task(uint_32 initial_data)
{ 
   _task_id task_id;
   
   //InitializeIO();
   
   InitializeNetworking(6, 6, 6, DEMOCFG_ENABLE_DHCP);  
   
   task_id = _task_create(0, CLIENT_TASK, 0);
   
   while (TRUE)
   {
       _time_delay(samplerate*60*1000);
       _task_restart(task_id, NULL, FALSE);
   }
   
   _task_block();
}

/* EOF */
